/* Http Webserver for Linux  */
/* Sumedh K                  */
/* www.sumedhk.com           */


#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>

#define MAXLINE 1024
#define SA struct sockaddr

void send_file(int,int);
void parsing_request(int,char *);
void *handle(void *);
void create_socket(int);

int file_length;

int main(int argc,char **argv)
{
  int port;
  if (argc != 2)
  {
    printf ("Please enter the port number.\n");
    return 1;
  }
  port = atoi(argv[1]);
  create_socket(port);
  return 0;
}

void create_socket(int port)
{
  int listenfd,connfd,clieLen=0;
  pthread_t thread;
  struct sockaddr_in servAddr,clieAddr;

  listenfd=socket(AF_INET,SOCK_STREAM,0);
  

  if(listenfd<0)
  {
    printf("Error : Server cannot open socket.\n");
    exit(-1);
  }
  
  memset(&servAddr,0,sizeof(servAddr));
  servAddr.sin_family=AF_INET;
  servAddr.sin_addr.s_addr=htonl(INADDR_ANY);
  servAddr.sin_port=htons(port);

  if(bind(listenfd,(SA *)&servAddr,sizeof(servAddr))<0)
  {
    printf("Error : Cannot bind IP and port.\n");
    exit(-1);
  }

  if(listen(listenfd,5)<0)
  {
    printf("Error : Listen error.");
    exit(-1);
  }

  while(1)
  {
    printf("\nServer listening at port %d \n",port);
    connfd=accept(listenfd,(SA *)&clieAddr,&clieLen);
 
    if(connfd<0)
    {
      printf("Error : Cannot accept connection socket.");
      continue;
    }

    printf("Connection accepted from %s\n",inet_ntoa(clieAddr.sin_addr));

    pthread_create(&thread,NULL,handle,(void *)connfd);    
    pthread_join(thread,NULL); 
    close(connfd);
  }
}

void *handle(void *arg)
{
  int sockid=(int)arg;
  char *buff=malloc(MAXLINE);

  bzero(buff,MAXLINE);
  
  if(recv(sockid,buff,MAXLINE,0)<=0)
  {
    printf("Recive error In Server.\n");
    exit(1);
  }
  parsing_request(sockid,buff); 
  return NULL;
}

void parsing_request(int sockid,char *buff)
{
  int fp;
  char *res_line=malloc(MAXLINE),path[100],*line;

  strcpy (path,"/home/sumedh/Programming/net");

  line=strtok(buff," ");
  line=strtok(NULL," ");
 
  if (strcmp(line,"/"))
  {
    strcat (path,line);
    printf ("Webpage path : %s\n",path);
    if((fp=open(path,O_RDONLY,"r"))==-1)
    {
      strcpy(res_line,"HTTP/1.1 404 Not Found\r\nContent_length:44\r\n\n <html><body><h1>404 : Not Found</h1></body></html>\r\n\n");
      
      if(send(sockid,res_line,strlen(res_line),0)==-1)
      {
	printf("Error : Cannot send data.\n");
	return;
      }
      printf("File Sent \n");
      return;
    }
  }
  else
    fp=open("/home/sumedh/Programming/net/index.htm",O_RDONLY,"r");
  
  file_length = lseek (fp,0,SEEK_END);
  printf ("Page file size : %d\n",file_length);

  lseek (fp,0,SEEK_SET);

  sprintf(res_line,"HTTP/1.1 200 OK\r\nContent_type: Application/Octet-stream,text/html\r\nContent_length:%d\r\n\n",file_length);
  
  if(send(sockid,res_line,strlen(res_line),0)==-1)
  {
    printf("Send Error In Server.");
    return;
  }
  send_file(fp,sockid);
  return;
}

void send_file(int fp,int sockid) 
{ 
  int bytes;
  char g_buff[MAXLINE*2];

  memset (g_buff,0,sizeof(g_buff));
  while ((bytes=read(fp,g_buff,MAXLINE*2))>0)
  {
    if (send(sockid,g_buff,bytes,0)==-1)
    {
      printf ("Error : Cannot send data.\n");
      return;
    }
  }

  return;
} 
